#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define COMPARE_TAB_SIZE 65536

char compareTab[COMPARE_TAB_SIZE][256];
int compareTabN = 0;

int main(int argc, char **argv) {
  int i;
  FILE *inFp1=NULL, *inFp2=NULL, *outFp=NULL;
  char s[256];
  int renamedN = 0;

  for (i=1; i<argc; i++) {
    if (!strcmp(argv[i], "-h")) {
      printf("%s inFileLong inFileLinesToRemove outFile\n",
	     argv[0]);
    } else if (!inFp1) {
      inFp1 = fopen(argv[i], "rb");
      if (!inFp1) {
	fprintf(stderr, "%s: couldn't open read file %s\n", argv[0], argv[i]);
	exit(EXIT_FAILURE);
      }
    } else if (!inFp2) {
      inFp2 = fopen(argv[i], "rb");
      if (!inFp2) {
	fprintf(stderr, "%s: couldn't open read file %s\n", argv[0], argv[i]);
	exit(EXIT_FAILURE);
      }
    } else if (!outFp) {
      outFp = fopen(argv[i], "wb");
      if (!outFp) {
	fprintf(stderr, "%s: couldn't open write file %s\n", argv[0], argv[i]);
	exit(EXIT_FAILURE);
      }
    }
  }

  if (!outFp) {
    fprintf(stderr, "%s: too little arguments\n", argv[0]);
    exit(EXIT_FAILURE);
  }

  while (fgets(compareTab[compareTabN], 256, inFp2)) {
    char *p;
    if (compareTab[compareTabN][0] != '#' &&
	(p = strchr(compareTab[compareTabN], '='))) {
      *p = '\0';
#if 0
      printf("Found symbol %d: \"%s\"\n", compareTabN, compareTab[compareTabN]);
#endif
      if (++compareTabN >= COMPARE_TAB_SIZE) {
	fprintf(stderr, "%s: too many symbols\n", argv[0]);
      }
    }
  }

  while (fgets(s, 256, inFp1)) {
    int found = 0, compLen;
    char *p;
    for (i=0; i<compareTabN; i++) {
      p = strchr(s, '=');
      if (p) {
	compLen = p-s;
	if (strlen(compareTab[i]) == compLen &&
		   !memcmp(s, compareTab[i], compLen)) {
	  found = 1;
	  renamedN++;
	}
      }
    }
    if (!found) {
      //      printf("p %s", s);
      fputs(s, outFp);
    } else {
      printf("Found and renamed symbol %s", s);
      fprintf(outFp, "_VSOS%s", s);
    }
  }

  printf("Renamed a total of %d symbols\n", renamedN);

  fclose(inFp1);
  fclose(inFp2);
  fclose(outFp);

  return EXIT_SUCCESS;
}
